import javax.microedition.lcdui.*;

class Block {
	// random number generator
	static java.util.Random random = new java.util.Random();
	int right;
	int bottom;
	int x,y;
	int type;
	int nextType;
	int rotN;

	// a handle onto the singleton Graphics object
	Graphics g;
	TetrisCanvas canvas;

	// public variables to control the behaviour of the thread
	public boolean stop;
	private boolean newBlock;
	private boolean bPainted;
	public boolean mbFailedToAdd;

	int oldX, oldY, oldRot;


	char [][][]blocks = {
							{ {0,0}, {1,0}, {0,1}, {1,1} },
							{ {0,0}, {1,0}, {0,1}, {1,1} }, // square
							{ {0,0}, {1,0}, {0,1}, {1,1} },
							{ {0,0}, {1,0}, {0,1}, {1,1} },

							{ {1,0}, {1,1}, {0,2}, {1,2} },
							{ {0,0}, {0,1}, {1,1}, {2,1} }, // L
							{ {0,0}, {1,0}, {0,1}, {0,2} },
							{ {0,0}, {1,0}, {2,0}, {2,1} },

							{ {0,0}, {0,1}, {0,2}, {1,2} },
							{ {0,0}, {0,1}, {1,0}, {2,0} }, // rev L
							{ {0,0}, {1,0}, {1,1}, {1,2} },
							{ {0,1}, {1,1}, {2,0}, {2,1} },

							{ {1,0}, {1,1}, {1,2}, {1,3} },
							{ {0,1}, {1,1}, {2,1}, {3,1} }, // Line
							{ {1,0}, {1,1}, {1,2}, {1,3} },
							{ {0,1}, {1,1}, {2,1}, {3,1} },

							{ {0,0}, {1,0}, {2,0}, {1,1} },
							{ {1,0}, {1,1}, {1,2}, {0,1} }, // T
							{ {0,1}, {1,1}, {2,1}, {1,0} },
							{ {0,0}, {0,1}, {0,2}, {1,1} },

							{ {0,0}, {0,1}, {1,1}, {1,2} },
							{ {0,1}, {1,1}, {1,0}, {2,0} }, // S
							{ {0,0}, {0,1}, {1,1}, {1,2} },
							{ {0,1}, {1,1}, {1,0}, {2,0} },

							{ {1,0}, {0,1}, {1,1}, {0,2} },
							{ {0,0}, {1,1}, {1,0}, {2,1} }, // InvS
							{ {1,0}, {0,1}, {1,1}, {0,2} },
							{ {0,0}, {1,1}, {1,0}, {2,1} },

						};

	Block(TetrisCanvas c) {
		super();
		canvas = c;
		rotN = 0;
		x=5;
		y=0;
		newBlock = true;
		type = Math.abs (random.nextInt() % 7);;
		nextType = Math.abs (random.nextInt() % 7);
		mbFailedToAdd = false;
	}

	private void addToCanvas() {
		char [][]blk;
		int i;

		blk = this.blocks[(type * 4) + rotN];
		for (i=0;i<4;i++) {
			canvas.droppedBlocks[blk[i][0]+x+1][blk[i][1]+y] = (char)(type+1);
		}
	}

	synchronized public boolean drop() {
		// Check that we can drop 1 - if we can't, return false & add the
		// current block to the canvas.droppedBlocks.
		if (!bPainted) return true;

		char [][]blk;
		int i;


		blk = this.blocks[(type * 4) + rotN];
		for (i=0;i<4;i++) {
			if (canvas.droppedBlocks[blk[i][0]+x+1][blk[i][1]+y+1] > 0) {
				newBlock = true;
				addToCanvas();
				x = 5;
				y = 0;
				type = nextType;
				nextType = Math.abs (random.nextInt() % 7);
				return false;
			}
		}
		bPainted = false;
		y = y+1;

		return true;
	}

	public void rotate(int rt) {
		char [][]blk;
		rotN = ( rotN + 1 ) & 0x3;
		int maxx = 0;
		/* but what if our new rotation has moved us offscreen to the right? */
		blk = this.blocks[(type * 4) + rotN];
		for (int i=0;i<4;i++) {
			if (blk[i][0]+x >= 13) {
				maxx = blk[i][0]+x;
			}
		}
		if (maxx > 0) {
			x -= (maxx - 12);
		}
		return;
	}

	public void move(int mv) {
		int i;
		char [][]blk;

		blk = this.blocks[(type * 4) + oldRot];
		for (i=0;i<4;i++) {
			if (canvas.droppedBlocks[blk[i][0]+x+mv+1][blk[i][1]+y] > 0) {
				return;
			}
		}
		x += mv;
	}
	/**
	 */
	public void animate() {
	}

    /**
     * Paint the block
     */
    synchronized void paint(Graphics g) {
		int i,xp,yp;
		char [][]blk;
		if (newBlock) {
			// check we can actually place the block!
			blk = this.blocks[(type * 4) + rotN];
			for (i=0;i<4;i++) {
			if (canvas.droppedBlocks[blk[i][0]+x+1][blk[i][1]+y] > 0) {
				// failed!
				mbFailedToAdd = true;
				return;
			}
		}

		} else {
			g.setColor(0x000000);
			blk = this.blocks[(type * 4) + oldRot];
			for (i = 0; i<4; i++) {
				xp = blk[i][0] + oldX;
				yp = blk[i][1] + oldY;
				xp *= 6; yp *= 6;
				g.fillRect(xp,yp,5,5);
			}
		}
		g.setColor(canvas.blockColor[type]);
		newBlock = false;
		oldX = x;
		oldY = y;
		oldRot = rotN;
		blk = this.blocks[(type * 4) + rotN];
		for (i = 0; i<4; i++) {
			xp = blk[i][0] + oldX;
			yp = blk[i][1] + oldY;
			xp *= 6; yp *= 6;
			g.fillRect(xp,yp,5,5);
		}
		bPainted = true;
    }

    void paintNext(Graphics g, int x, int y) {
		int i,xp,yp;
		char [][]blk;
		blk = this.blocks[nextType * 4];
		g.setColor(canvas.blockColor[nextType]);
		for (i = 0; i<4; i++) {
			xp = blk[i][0];
			yp = blk[i][1];
			xp *= 6; yp *= 6;
			g.fillRect(xp+x,yp+y,5,5);
		}
	}

    public String toString() {
	return super.toString(); // + " x = " + posX + ", y = " + posY;
    }

}
