/**
 *
 * Crappy cheap tetris close, Lee Benfield 03/2004
 *
 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;


public class Tetris extends MIDlet implements CommandListener {

    Display display;
    TetrisCanvas canvas;		// The main screen
    private Command exitCommand   = new Command("Exit", Command.EXIT, 99);
    private Command toggleCommand = new Command("Stop/Go", Command.SCREEN, 1);
    private Command aboutCommand  = new Command("About", Command.HELP, 30);

    /*
     * Create the canvas
     */
    public Tetris() {
		display = Display.getDisplay(this);

		canvas = new TetrisCanvas(display);
		canvas.addCommand(exitCommand);
		canvas.addCommand(aboutCommand);
		canvas.setCommandListener(this);
    }

    public void startApp() throws MIDletStateChangeException {
		canvas.start();
    }

    public void pauseApp() {
		canvas.pause();
    }

    public void destroyApp(boolean unconditional)
	throws MIDletStateChangeException {
		canvas.destroy();
    }

    /*
     * Respond to a command issued on the Canvas.
     */
    public void commandAction(Command c, Displayable s) {
		if (c == toggleCommand) {
			if (canvas.isPaused())
				canvas.start();
			else
				canvas.pause();
		} else if (c == exitCommand) {
			try {
				destroyApp(false);
				notifyDestroyed();
			} catch (MIDletStateChangeException ex) {
			}
		} else if (c == aboutCommand) {
			About.showAbout(display);
			canvas.redraw();
		}
    }
}
