/**
 *
 * Crappy cheap tetris close, Lee Benfield 03/2004
 *
 */

// import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.*;

public class TetrisCanvas extends javax.microedition.lcdui.Canvas implements KeyRepeater {
	private KeyRepeat m_repeat = new KeyRepeat(this);
    Display display;

	int nDropDelay;
	int nDropWait;
	boolean paused;
	boolean mbRedraw;
	boolean mbRedrawField;
	boolean mbRedrawNext;
	int mnTotLines;
	int mnTotScore;
	int mnLinesToNext;
	int mnLevel;
    int width, height;
	int frame;
	int m_nKeyWait;

	public char [][]droppedBlocks;
	public int []blockColor;

	Block block;

    public TetrisCanvas (Display d) {

		display = d;		// save the display
		width = getWidth();
		height = getHeight();
        m_repeat.setSleepPeriod(30);
	    m_repeat.start();
	    m_nKeyWait = 5;
	    paused = true;
	    frame = 0;
	    block = new Block(this);
	    mbRedraw = true;
	    mbRedrawField = true;
	    mbRedrawNext = true;
	    nDropDelay = 15;
	    nDropWait = 0;
	    droppedBlocks = new char[15][22];
	    for (int x=0;x<15;x++) {
			droppedBlocks[x][21] = 1;
		}
	    for (int y =0;y<22;y++) {
			droppedBlocks[0][y] = 1;
			droppedBlocks[14][y] = 1;
		}
		blockColor = new int[7];
		blockColor[0] = 0xFF0000;
		blockColor[1] = 0xFF00FF;
		blockColor[2] = 0x00FFFF;
		blockColor[3] = 0xFFFF00;
		blockColor[4] = 0xAAFFAA;
		blockColor[5] = 0xC0F0C0;
		blockColor[6] = 0x83AAFF;

		mnTotLines = 0;
		mnTotScore = 0;
		mnLinesToNext = 10;
		mnLevel = 1;
		//	    ball.start();
    }

	private boolean bLineFull(int nLine) {
		int x;
		for (x=1;x<14;x++) {
			/* make 1d array access? */
			if (droppedBlocks[x][nLine] == 0) {
				return false;
			}
		}
//		System.out.println("Line "+ x + " full");
		return true;
	}

	private void copyLine(int out, int in) {
		int x;
		if (out==in) return;
//		System.out.println("copy line "+ out + "<--" + in);
		for (x=1;x<14;x++) {
			/* make 1d array access? */
			droppedBlocks[x][out] = droppedBlocks[x][in];
		}
	}

	private void clearLine(int y) {
		int x;
		for (x=1;x<14;x++) {
			droppedBlocks[x][y] = 0;
		}
	}

	private void checkLines() {
		int outLine, inLine;
		int lines = 0;
		for (outLine=20,inLine=20;inLine>=0;inLine--) {
			if (lines < 5 && bLineFull(inLine)) {
				lines+=1;
			} else {
				/* copy - if we're already on the dest line, don't copy! */
				copyLine(outLine, inLine);
				outLine--;
			}
		}
		if (outLine >= 0) {
			for (;outLine>=0;outLine--) {
				clearLine(outLine);
			}
			mnTotLines += lines;
			switch (lines) {
				case 1:
					mnTotScore += 10;
					break;
				case 2:
					mnTotScore += 30;
					break;
				case 3:
					mnTotScore += 80;
					break;
				default: /* duh */
					mnTotScore += 180;
					break;
			}
			mnLinesToNext -= lines;
			if (mnLinesToNext <= 0) {
				mnLinesToNext += 10;
				mnLevel += 1;
			    nDropDelay -= 2;
			    if (nDropDelay < 1) nDropDelay = 1;
			}
			mbRedrawField = true;
		}
//		System.out.println("checkLines " + lines + "," + mbRedrawField);
	}

	protected void redrawField(Graphics g) {
		int x,y,xp,yp;
		char db;
//		System.out.println("Redrawing field.");
		for (yp=0,y=0;y<21;y++,yp+=6) {
			for (xp=0,x=1;x<14;x++,xp+=6) {
				db = droppedBlocks[x][y];
				if (db == 0) {
					g.setColor(0);
				} else {
					g.setColor(blockColor[db-1]);
				}
				g.fillRect(xp,yp,5,5);
			}
		}
		/* And redraw the line count */

		g.setColor(0x0);
		g.fillRect(85,55,40,15);
		g.fillRect(85,83,40,15);
		g.fillRect(85,111,40,15);
		g.setColor(0xFFFFFF);
		g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
		g.drawString("" + mnTotLines , 85, 55, Graphics.TOP|Graphics.LEFT);
		g.drawString("" + mnTotScore , 85, 83, Graphics.TOP|Graphics.LEFT);
		g.drawString("" + mnLevel , 85, 111, Graphics.TOP|Graphics.LEFT);

		mbRedrawField = false;
	}

	protected void redrawNext(Graphics g) {
		g.setColor(0);
		g.fillRect(84,15,20,26);
		block.paintNext(g,86,17);

		mbRedrawNext = false;
	}

	protected void redrawCanvas(Graphics g) {

		int xp,yp;
        int x = g.getClipX();
        int y = g.getClipY();
        int w = g.getClipWidth();
        int h = g.getClipHeight();

		g.setColor(0x0);
		g.fillRect(x, y, w, h);
		int i,ii;
		g.setColor(0x999999);
		for (yp=0,ii=0;yp<=21;yp++,ii+=6) {
			g.drawLine(0,ii-1,77,ii-1);
		}
		for (xp=0,ii=0;xp<=13;xp++,ii+=6) {
			g.drawLine(ii-1,0,ii-1,125);
		}
		g.setColor(0xFFFFFF);
		g.drawRect(83,14,22,28);

		g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));
		g.drawString("Next:", 80, 0, Graphics.TOP|Graphics.LEFT);
		g.drawString("Lines:", 80, 44, Graphics.TOP|Graphics.LEFT);
		g.drawString("Score:", 80, 72, Graphics.TOP|Graphics.LEFT);
		g.drawString("Level:", 80, 100, Graphics.TOP|Graphics.LEFT);
		g.setColor(0x0);
		g.fillRect(85,55,40,15);
		mbRedraw = false;
	}

    protected void paint(Graphics g) {

		if (mbRedraw) redrawCanvas(g);
		if (mbRedrawField) redrawField(g);
		if (mbRedrawNext) redrawNext(g);

		block.paint(g);
    }

    protected void keyPressed(int keyCode) {
		m_nKeyWait = 0;
        m_repeat.startRepeat(getGameAction(keyCode));
	}

	protected void keyReleased(int keyCode) {
        m_repeat.stopRepeat(getGameAction(keyCode));
    }

	public void performEvents() {
		// drop current block by 1.
//		repaint();
	}

	public void performAction(int action) {
		boolean bDropped =false;
		boolean bDropRes = true;
		boolean bSomethingHappened = false;
		if (m_nKeyWait <= 0) {
			m_nKeyWait = 4;
			switch (action) {
			case LEFT:
				block.move(-1);
				bSomethingHappened = true;
				break;
			case RIGHT:
				block.move(1);
				bSomethingHappened = true;
				break;
			case UP:
				m_nKeyWait = 6;
				block.rotate(1);
				bSomethingHappened = true;
				break;
			case DOWN:
				bDropRes = block.drop();
				bDropped = true;
				m_nKeyWait = 0;
				bSomethingHappened = true;
				break;
			}
		} else {
			m_nKeyWait--;
		}
		if (!bDropped && ++nDropWait > nDropDelay) {
			nDropWait = 0;
			bDropRes = block.drop();
			bSomethingHappened = true;
			bDropped = true;
		}
		if (bDropped && !bDropRes) {
			if (block.mbFailedToAdd) {
				// Game over dude!
			} else {
				mbRedrawNext = true;
				checkLines();
			}
		}
		if (bSomethingHappened) {
			repaint();
		}
    }

    /**
     * Destroy
     */
    void destroy() {
    }


    /*
     * Return whether the canvas is paused or not.
     */
    boolean isPaused() {
		return paused;
    }

    void pause() {
		if (!paused) {
	    	paused = true;
		}
	 	mbRedraw = true;
	    mbRedrawField = true;
	 	mbRedrawNext = true;
		repaint();
    }

    /*
     * Start creates a new thread for each ball and start it.
     */
    void start() {
		if (paused) {
	    	paused = false;
		    display.setCurrent(this);
		}
	 	mbRedraw = true;
	    mbRedrawField = true;
	 	mbRedrawNext = true;
		repaint();
    }

	void redraw() {
		mbRedraw = true;
		mbRedrawField = true;
		mbRedrawNext = true;
		repaint();
	}
}



/*
 *  We don't use the keyRepeated functionality provided by the phone,
 * as it's probably shite and we can't determine the rate at which
 * messages are passed down; instead use the (seemingly) standard trick
 * of having a worker thread dispatching keypresses.
 *
 * See http://www.microjava.com/articles/HappyFace2.java
 */

/**
 * Emulates the key repeat functionality if it does not exist in the device.
 */
class KeyRepeat extends Thread
{
   private boolean            m_cancel = false;
   private long               m_sleepTime = 20;
   private int                m_gameAction = 0;
   private final KeyRepeater  m_ui;

   /**
    * Creates a KeyRepeated object and saves the reference to the UI
    * in which the key repeat emulation shoudl occur.
    *
    * @param ui The UI in which the key repeat emulation shoudl occur.
    */
   public KeyRepeat(KeyRepeater ui)
   {
      m_ui = ui;
   }

   /**
    * Stops the thread.
    */
   public void cancel()
   {
      m_cancel = true;
   }

   /**
    * Returns the game action currently repeated.
    *
    * @return The game action currently repeated.
    */
   public int getGameAction()
   {
      return m_gameAction;
   }

   /**
    * Sets the amount of time between actions.
    *
    * @param sleepTime The amount of time to sleep between actions.
    */
   public void setSleepPeriod(long sleepTime)
   {
      m_sleepTime = sleepTime;
   }

   /**
    * Start the key to be repeated.
    *
    * @param gameAction The game action that is to be performed.
    */
   public void startRepeat(int gameAction)
   {
      m_gameAction = gameAction;
   }

   /**
    * Stop the key from being repeated.  If the currently repeated key is
    * the same as the one that is to be stopped then stop; otherwise
    * ignore it, we must be repeating a different key.
    *
    * @param gameAction The game action that is to be performed.
    */
   public void stopRepeat(int gameAction)
   {
      if (gameAction == m_gameAction)
      {
         m_gameAction = 0;
      }
   }

   /**
    * Perform the repetition of the key.
    */
   public void run()
   {
      while (!m_cancel)
      {
         // yield to other threads if there is no key to be repeated
//         while (m_gameAction == 0 && !m_cancel)
//         {
//            Thread.yield();
//         }
		 m_ui.performEvents();
         // perform the repetition of the last key
         m_ui.performAction(m_gameAction);
         // wait for a little bit
         try
         {
            sleep(m_sleepTime);
         }
         catch (InterruptedException e)
         {
         }
      }
   }
}



/**
 * This interface is used for any object that wants to emulate repeating keys.
 */
interface KeyRepeater
{
   /**
    * Called when a game action is to be performed.
    *
    * @param gameAction The game action that is to be performed.
    */
   public void performAction(int gameAction);
   public void performEvents();
}
